﻿Imports System.Net
Imports System.Text

Public Class Main

   Friend Property MapCustomerStreet As String = String.Empty
   Friend Property MapPostalCode As String = String.Empty
   Friend Property MapCity As String = ""


   Public Shared Function IsInternetConnAvailable() As Boolean

        Dim objUrl As New Uri("http://www.macoratti.net/") 'pode ser qq endereço
      Dim objWebReq = WebRequest.Create(objUrl)
      objWebReq.Credentials = CredentialCache.DefaultCredentials
      Dim objResp As WebResponse = Nothing

      Try
         objResp = objWebReq.GetResponse
         If objResp.ContentLength > 0 Then
            If Not (objResp Is Nothing) Then objResp.Close()
            objWebReq = Nothing

            Return True
         Else
            If Not (objResp Is Nothing) Then objResp.Close()
            objWebReq = Nothing
                MessageBox.Show("Sem conexão com a internet!", "Conexão Internet", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return False
         End If

      Catch ex As Exception

         If Not (objResp Is Nothing) Then objResp.Close()
         objWebReq = Nothing
         MessageBox.Show(ex.Message.ToString)
         Return False
      End Try

   End Function

   Friend Sub GetMap()

      Try

      
      TopLevelControl.Cursor = Cursors.WaitCursor

      With Me

         If IsInternetConnAvailable() = True Then

            .btnPageSetUp.Enabled = True
            .btnPrint.Enabled = True
            .btnGo.Enabled = True

            Dim addrToSearch As New StringBuilder()

            Try

               .wBrowser.Refresh(WebBrowserRefreshOption.Completely)

               addrToSearch.Append("http://maps.google.com/maps?q=")

               addrToSearch.Append(If(MapCustomerStreet = Nothing, My.Settings.MyAddress.ToString & ", ", MapCustomerStreet & ", "))

               addrToSearch.Append(If(MapPostalCode = Nothing, My.Settings.MyPostalCode & " ", MapPostalCode & " "))

               addrToSearch.Append(If(MapCity = Nothing, My.Settings.MyPostalCity & ", ", MapCity & ","))

               addrToSearch.Append(My.Settings.MyCountry)

               addrToSearch.Append("&output=embed&z=60")

                        .wBrowser.Navigate(addrToSearch.ToString())

               .txtAddress.Text = MapCustomerStreet.ToString
               .txtPostalCode.Text = MapPostalCode.ToString
               .txtPostalCity.Text = MapCity.ToString

               MapCustomerStreet = Nothing
               MapPostalCode = Nothing
               MapCity = Nothing
               addrToSearch = Nothing

            Catch ex As Exception
               MessageBox.Show(ex.Message.ToString)
            End Try

         End If
      End With
      Catch ex As Exception
            MessageBox.Show(ex.Message, "Houve um problema durante a obtenção das informações com o Google Maps")
      Finally
         TopLevelControl.Cursor = Cursors.Default
      End Try
   End Sub

   Private Sub CloseIt()
      Close()
   End Sub

   Private Sub btnGo_Click(sender As System.Object, e As System.EventArgs) Handles btnGo.Click
      Try
         If String.Compare(txtAddress.Text, "", False) <> 0 Then
            MapCustomerStreet = txtAddress.Text
         Else
            Return
         End If
         If String.Compare(txtPostalCode.Text, "", False) <> 0 Then
            MapPostalCode = txtPostalCode.Text
         Else
            Return
         End If
         If String.Compare(txtPostalCity.Text, "", False) <> 0 Then
            MapCity = txtPostalCity.Text
         Else
            Return
         End If

         GetMap()

      Catch ex As Exception
            MessageBox.Show(ex.Message, "Houve um problema durante a obtenção das informações com o Google Maps")
      End Try

   End Sub

   Private Sub btnPrint_Click(sender As System.Object, e As System.EventArgs) Handles btnPrint.Click
      wBrowser.ShowPrintPreviewDialog()
      If wBrowser.Document.Title = Nothing Then
         wBrowser.Document.Title = String.Format("{0} ,{1} ,{1}", txtAddress.Text.Trim, txtPostalCity.Text.Trim)
      End If
   End Sub

   Private Sub btnPageSetUp_Click(sender As System.Object, e As System.EventArgs) Handles btnPageSetUp.Click
      wBrowser.ShowPageSetupDialog()
   End Sub

   Private Sub btnClose_Click(sender As System.Object, e As System.EventArgs) Handles btnClose.Click
        BeginInvoke(New MethodInvoker(AddressOf CloseIt))
   End Sub

   Private Sub Main_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
      txtAddress.Text = My.Settings.MyAddress.ToString
      txtPostalCode.Text = My.Settings.MyPostalCode.ToString
      txtPostalCity.Text = My.Settings.MyPostalCity.ToString
      GetMap()  'Show default location.
   End Sub

   Private Sub btnSetDefault_Click(sender As System.Object, e As System.EventArgs) Handles btnSetDefault.Click

      My.Settings.MyAddress = txtDefaultAddress.Text.ToString
      My.Settings.MyPostalCode = txtDefaultZipCode.Text.ToString
      My.Settings.MyPostalCity = txtDefaultPostalCity.Text.ToString

      My.Settings.Save()

      MapCustomerStreet = My.Settings.MyAddress
      MapPostalCode = My.Settings.MyPostalCode
      MapCity = My.Settings.MyPostalCity

      GetMap()
   End Sub

End Class
